package com.zhongzheng.modules.goods.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.course.vo.CourseVo;
import com.zhongzheng.modules.goods.bo.GoodsCourseAddBo;
import com.zhongzheng.modules.goods.bo.GoodsCourseEditBo;
import com.zhongzheng.modules.goods.bo.GoodsCourseQueryBo;
import com.zhongzheng.modules.goods.domain.GoodsCourse;
import com.zhongzheng.modules.goods.mapper.GoodsCourseMapper;
import com.zhongzheng.modules.goods.mapper.GoodsMapper;
import com.zhongzheng.modules.goods.service.IGoodsCourseService;
import com.zhongzheng.modules.goods.vo.GoodsCourseVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 商品课程关系Service业务层处理
 *
 * @author hjl
 * @date 2021-10-12
 */
@Service
public class GoodsCourseServiceImpl extends ServiceImpl<GoodsCourseMapper, GoodsCourse> implements IGoodsCourseService {

    @Autowired
    private GoodsCourseMapper goodsCourseMapper;


    @Override
    public GoodsCourseVo queryById(Long id){
        GoodsCourse db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, GoodsCourseVo.class);
    }

    @Override
    public List<GoodsCourseVo> queryList(GoodsCourseQueryBo bo) {
        LambdaQueryWrapper<GoodsCourse> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getGoodsId() != null, GoodsCourse::getGoodsId, bo.getGoodsId());
        lqw.eq(bo.getCourseId() != null, GoodsCourse::getCourseId, bo.getCourseId());
        return entity2Vo(this.list(lqw));
    }

    @Override
    public List<CourseVo> selectList(Long goodsId) {
        return goodsCourseMapper.selectList(goodsId);
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<GoodsCourseVo> entity2Vo(Collection<GoodsCourse> collection) {
        List<GoodsCourseVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, GoodsCourseVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<GoodsCourse> page = (Page<GoodsCourse>)collection;
            Page<GoodsCourseVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(GoodsCourseAddBo bo) {
        GoodsCourse add = BeanUtil.toBean(bo, GoodsCourse.class);
        validEntityBeforeSave(add);
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(GoodsCourseEditBo bo) {
        GoodsCourse update = BeanUtil.toBean(bo, GoodsCourse.class);
        validEntityBeforeSave(update);
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(GoodsCourse entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
